char dummy=0;
#define OSNAME "ilas-OS"
#define OSVERSTR "V0.5"
#define OSVERMAJOR 0
#define OSVERMINOR 5
#define ENDSTR "Now leaving "OSNAME". Cu$"

#define UCHR unsigned char
#define UINT unsigned int
#define ULNG unsigned long
#define nil NULL
#define EINS ((void *) 1)

typedef UCHR *PUCHR;
typedef UINT *PUINT;
typedef ULNG *PULNG;

typedef char *PCHR;
typedef int *PINT;
typedef long *PLNG;

#define SEGSTR(x) ((char *) MK_FP((x),0))
#define STRSEG(x) ((UINT) FP_SEG((x)))
#define yield idle
#define BEGINASM { _asm {
#define ENDASM } }

void callmeback(void *proc)
    BEGINASM
        push ds
        push bp
        call proc
        pop bp
        pop ds
    ENDASM

// Includes
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <dos.h>
#include <bios.h>
#include <stdarg.h>

// For the mouse
char *mpbuf=NULL;
UINT mpbufvalid=0;
UINT xsize=13,ysize=12;
// char *mptr="A\nAA\nAPA\nAPPA\nAPPPA\nAPPPPA\nAPPPPPA\nAPPPPPPA\nAPPPPPPPA\nAPPPPPPPPA\nAPPPPPPPPPA\nAPPPPPPPPPPA\nAAAAAAAAAAAAA\n    APPA\n     APPA\n      APPA\n       APPA\n         AA";
char *mptr="PPPPPPPPPPH\nPPPH\nPPPH\nPHPPH\nPH PPH\nPH  PPH\nPH   PPH\nPH    PPH\nPH     PPH\nPH      PPH\n         PPH\n          PPH\n";
char *tmpdir="/init/tmp/tmp";

int debfile=0,debdos=0;
UINT curtask=0;
int logo=0;

#define getpixel mygetpixel
#define putch myputch
#define puts myputs
#define printf myprintf
int fswrite(int handle, unsigned howmuch, char *buffer);

beeper()
    BEGINASM
        mov ax, 0e07h
        int 10h
    ENDASM

putch(char x)
    {
    if(logo)
        { if(debfile) fswrite(debfile,1,&x); }
    else
        _asm
            {
            mov ah, 0eh
            mov al, x
            mov bl, 0fh
            int 10h
            }
    }

putstr(char *x)
    {
    while(*x != 0)
        {
        if(*x == '\n')
            putch('\r');
        putch(*(x++));
        }
    }

putnum(UINT n)
    {
    char nb[5];
    nb[4] = n % 10 + '0'; n = n / 10;
    nb[3] = n % 10 + '0'; n = n / 10;
    nb[2] = n % 10 + '0'; n = n / 10;
    nb[1] = n % 10 + '0'; n = n / 10;
    nb[0] = n % 10 + '0'; n = n / 10;
    putch(nb[0]);
    putch(nb[1]);
    putch(nb[2]);
    putch(nb[3]);
    putch(nb[4]);
    putch(' ');
    }

puthex(UINT n)
    {
    char nb[4];
    char *d="01234567890ABCDEF";
    nb[3] = d[n % 16] ; n = n / 16;
    nb[2] = d[n % 16] ; n = n / 16;
    nb[1] = d[n % 16] ; n = n / 16;
    nb[0] = d[n % 16] ;
    putch(nb[0]);
    putch(nb[1]);
    putch(nb[2]);
    putch(nb[3]);
    putch(' ');
    }

// Some defines
#define TASKS_MAX 16
#define MSGTAB_MAX 8
#define MOUNT_MAX 32
#define FILE_MAX 128
#define ULWM_MAXWIN 64

UINT stdtty;
char globuf[512];
char *endstr=ENDSTR;
UINT cursoron=0;

#define mouse_drawbegin() { if(cursoron != 0) mouse_cursor(cursoron+1); }
#define mouse_drawend() { if(cursoron > 1) mouse_cursor(cursoron-1); }
#define mouse_begindraw mouse_drawbegin
#define mouse_enddraw mouse_drawend

// Some prototypes
gui_cleanup(UINT pid);
void wm_paint(UINT flgs, UINT wnd);
wm_keyb(UINT action, UINT code);
wm_mouse(UINT x, UINT y, UINT btn);
wm_cleanup(UINT proc);
int textwidth(int fntid, char *txt);
int textheight(int fntid, char *txt);
#define fsopen(a,b) (fsopen2((a),(b), 0))
int fsopen2(char *abspath, int whobel, int cancreate);
void fsclose(int);
void osexit();
int fsread(int handle, unsigned howmuch, char *buffer);
char fsgetc(int handle);
UINT fsgetw(int handle);
ULNG fsgetdw(int handle);
void fsgets(int handle, char *buf, UINT buflen);
int fsputs(int handle, char *str);
#define fsputsnobr(handle,str) (fswrite((handle),strlen((str)),(str)))
void ktask(void);
UINT ffwrite(UINT hndl, UINT numread, void *buf);
int peekmessage(UCHR pid);
waitmessageorhandle(int pid, int handle);
void dispatchmessage(UINT from, UINT to, UINT msg, UINT a, UINT b, UINT c);

// Some variables and structures
int fgwin=0;
struct msgtab
    {
    UCHR used;
    UCHR sender;
    UINT msgid;
    UINT a;
    UINT b;
    UINT c;
    };

struct ttable
    {
    char used;
    char *filename;
    char *params;
    char *curdir;
    unsigned char status;
    unsigned long status2;
    unsigned ss;
    unsigned sp;
    unsigned char msgstat;
    unsigned Hstdin;
    unsigned Hstdout;
    unsigned Hstderr;
    struct msgtab msg[MSGTAB_MAX];
    } tasks[TASKS_MAX];

struct mtab
    {
    char *pathname;             // where it is mounted (leading & trailing "/", eg. "/fs/diskc/")
    char *params;               // parameters for the fs-driver (fg. the source)
    int driverid;               // the driver
    unsigned char drvres[16];   // some space for the driver to store internal data
    } mdevs[MOUNT_MAX];

struct fhndtab
    {
    char *filename;             // the name of the open file
    int mtabent;                // the entry in the mtab for getting driver-infos
    unsigned long pos;          // current file-position
    unsigned long len;          // file-length
    unsigned char drvres[15];   // some space for the driver to store internal data
    unsigned char tmpfile;      // If set, the file is deleted after fsclose()
    int owner;                  // Who the handle belongs to
    } fhandles[FILE_MAX];

struct awnd
    {
    unsigned char used;
    int owner;
    void *wprg;
    char *title;
    void *icon;
    unsigned fill;
    unsigned char flgs;
    void *actctrl;
    };

struct ulwmdata
    {
    struct awnd windat[ULWM_MAXWIN];
    }
  *uldat;

void debstr(char *str)
    {
    if(debfile)
        {
        fswrite(debfile,strlen(str),str);
        fswrite(debfile,2,"\r\n");
        }
    else if(debdos)
        {
        ffwrite(debdos,strlen(str),str);
        ffwrite(debdos,2,"\r\n");
        }
    }

void puts(char *str)
    {
    debstr(str);
    if(!logo) { putstr(str); putstr("\r\n"); }
    }

int printf(char *dat, ...)
    {
    char ausgabe[255];
    va_list param;
    va_start(param,dat);
    vsprintf( ausgabe, dat, param );
    debstr(ausgabe);
    if(!logo) putstr(ausgabe);
    }

#define debnum debint
#define debint putnum
#define debhex puthex
/* void debint(int nr)
    {
    char buf[16];
    sprintf(buf,"%i\r\n",nr);
    if(debfile)
        fswrite(debfile,strlen(buf),buf);
    else
        fswrite(debdos,strlen(buf),buf);
    } */

// Own includes
#include "logospm.h"
#include "error.h"
#include "memman.h"
#include "strlist.h"
#include "xms.h"
#include "drvlist.h"
#include "filefkt.h"
#include "fs.h"
#include "task.h"
#include "timer.h"
#include "disdrv.h"
#include "mouse.h"
#include "keyb.h"
#include "wminterf.h"
#include "controls.h"
#include "gui.h"
#include "api.h"
UCHR idledata[] = { 0x8C,0xD1,0x89,0xE3,0xB8,0xBA,0xAB,0xCD,0xF0,0xFA,0x8E,0xD1,0x89,0xDC,0xFB,0xCF };
#include "ulsop.h"

idle()
    {
    _asm
        {
        push ds
        push bp
        push si
        push di
        int 0F1h
        pop di
        pop si
        pop bp
        pop ds
        }
    }

printmsg(int t)
    {
    int i;
    while((i = peekmessage(t)) >= 0)
        printf("MSG From:%i To:%i ID:%i A:%i B:%i C:%i\n",tasks[t].msg[i].sender,t,tasks[t].msg[i].msgid,tasks[t].msg[i].a,tasks[t].msg[i].b,tasks[t].msg[i].c);
    }

int cmov_id=-1,cmov_x,cmov_y;

char *getval(char *nam, char **argv)
    {
    int i,j=strlen(nam);
    for(i=0;argv[i] != NULL;i++)
        if(matchfirst(argv[i],nam))
            if(argv[i][j] == '=')
                return &(argv[i][j+1]);
            else
                return EINS;
    return NULL;
    }

strtoint(char *str, int whatifnull) { return str > EINS ? atoi(str) : whatifnull; }

/* strl_print(char *titl, strlist *sl)
    {
    int i;
    printf("\nSTRL %s (%i items):\n",titl,sl->count);
    for(i=0;i<sl->count;i++)
        printf("%i: %s  ;  ",i,strl_getitem(sl,i));
    } */

main(int argc, char **argv)
    {
    char *path=strdup(argv[0]);
    char *p;
    int i,j,k;
    int a,b;
//    strlist sl;

    puts("-------- Loading "OSNAME" "OSVERSTR" --------");
    puts("(C) 2002-2003 by Simon Laburda (simbone@gmx.at)");
    debdos = ffopen("deb1",1);
    if(getval("NOLOGO",argv))
        puts("{{ Fullscreen VGA-Logo disabled }}");
    else
        logo = displaylogo();

    if((p = getval("TMP",argv)) > EINS)
        tmpdir = p;
    if((p = getval("INIT",argv)) > EINS)
        { free(path); path = strdup(p); }
    if(getval("NOUMB",argv))
        puts("{{{ UMBs disabled via commandline }}}");
    else
        _asm        // Try to enable UMBs to get more memory from DOS
            {
            mov ax, 5803h
            mov bx, 1
            int 21h
            }

    ulsop_init();
    mem_init(strtoint(getval("LEAVEMEM",argv),512));
    timer_init();
    if(getval("NOXMS",argv))
        puts("{{{ XMS disabled via commandline }}}");
    else
        xms_init();
    drvlist_init();
    _asm
        {
        push ds
        mov ax, SEG apicall
        mov ds, ax
        mov dx, OFFSET apicall
        mov ax, 25F0h
        int 21h

        mov ax, SEG idledata
        mov ds, ax
        mov dx, OFFSET idledata
        mov ax, 25F1h
        int 21h

        pop ds
        }
    if(getval("NOHLT",argv))
        {
        puts("{{ HLT powersaving disabled }}");
        dohlt = 0;
        }
    i = strlen(path);
    while(path[i] != '\\') i--;
    path[i+1] = 0;
    printf("Mounting DOS-FS (%s) @ /init/\n",path);
    if((i=fsmount("/init/",path,128)) < 0)
        {
        printf("ERROR: %s (Code %i)\n",errtostr(i),i);
        exit(1);
        }
    printf("Mounting DEV-FS @ /dev/\n",path);
    if((i=fsmount("/dev/",NULL,131)) < 0)
        {
        printf("ERROR: %s (Code %i)\n",errtostr(i),i);
        exit(1);
        }
    if((p = getval("MTMP",argv)) > EINS)
        {
        printf("Mounting DOS-FS (%s) @ /tmp/\n",p);
        if((i=fsmount("/tmp/",p,128)) < 0)
            {
            printf("ERROR: %s (Code %i)\n",errtostr(i),i);
            exit(1);
            }
        }
    ffclose(debdos); debdos = 0;
    if(getval("DEB",argv))
        debfile = fsopen2("/init/deb",0,1);
    else debfile = 0;

/*
    printf("\n\nFifo-test:\n");
    p = mem_malloc(256,0);
    if((i = fsopen("/dev/fifo",0)) < 0)
        {
        printf("Error /dev/fifo: %s\n",errtostr(i));
        exit(1);
        }
    fswrite(i,4,"Test");
    fswrite(i,21,"-1-2-3-4-5-6-7-8-9-10");
    fsgets(i,p,256); printf("Read back: %s\n",p);
    fswrite(i,30,"ABCDEFGHIJKLMNOPQRSTUVWXYZ1234");
    fsgets(i,p,256); printf("Read back: %s\n",p);
    fsclose(i);
    exit(0);
*/

    b = fsopen("/dev/tty0",0);

    stdtty = b;
    fsclose(a);
    task_init(argv[1]);

    // DO THIS--------------

    puts("Creating process /init/osinit");
    tasks[0].curdir = "/init/";
    tasks[0].filename = "ILAS-Kernel";
    if((i=task_create("/init/osinit","",0)) < 0)
        {
        printf("Cannot load startup-task: %s\n",errtostr(i));
        exit(4);
        }
    srand(clock() + *((long *) MK_FP(0x40,0x6C)) + argc);
    puts("Beginning multitasking");
    tasks[0].used = 1;
    logo = 1;
    sendmessage(1,0,1000,0,0,0);

    while(1)
        {
//        printmsg(0);        
//        idle();
        
        i = getmessage(0);
        debstr("GOTKRNLMSG");
        if(tasks[0].msg[i].msgid == MSG_KILL)
            {
            debstr("ESCterm");
            osexit();
            }
        else if(tasks[0].msg[i].msgid == MSG_FLASH)
            {
            clearscr(tasks[0].msg[i].a);
            wm_paint(0xF,fgwin);
            } 
        }
    }

void osexit()
    {
    UINT i;
    void *x;
    timer_uninit();
    for(i=0;i<128;i++)
        if(drvlist[i].used)
            {
            x = drvlist[i].drvcall;
            _asm
                {
                push ds
                mov ax, 4
                call x
                pop ds
                }
            }
    _asm
        {
        mov ax, SEG endstr
        mov ds, ax
        mov ah, 9
        mov dx, (UINT) FP_OFF(endstr)
        int 21h
        }
    exit(0);
    }

