CPU 286
ORG -3

%macro putdeb 1
    mov ax, 0ABBDh
    mov bx, %1
    int 0F0h
%endmacro

    db '->'     ; Begin
    db 0        ; Flags

;-------------------------------------------------

        push cs
        pop ds

        putdeb itest
        mov ax, 21h
        mov bx, 2000
        int 0F0h
        putdeb idone

        mov ax, 1010h       ; Load DIB to DDB
        mov si, einbild
        mov bx, 1
        int 0F0h
        mov ax, es

        or ax, ax
        jz errend

        mov ds, ax          ; Draw DIB

        mov di, 270

        drl:
        push di
        mov ax, 100eh
        mov bx, di
        mov cx, 120
        xor si, si
        xor di, di
        int 0F0h
    
        push ds
        int 0F1h
        pop ds
        pop di

        dec di
        jnz drl
        
        mov ax, cs
        mov ds, ax

        mov ax, 1003h       ; Draw Sprite
        mov cx, 130
        mov dx, cx
        mov bx, apic
        xor si, si
        int 0F0h

;        mov ax, 1006h       ; Textout
;        mov cx, 100
;        mov dx, 50
;        mov si, fntdat
;        mov di, eintext
;        int 0F0h

;        mov ax, 1006h       ; Textout
;        mov si, fntdat2
;        mov dx, 100
;        int 0F0h

        mov ax, 1001h       ; Hline
        mov bx, 50
        mov cx, 160
        mov dx, 300
        mov di, 15
        xor si, si
        int 0F0h

        mov ax, 1002h       ; Vline
        mov bx, 50
        mov cx, 310
        mov dx, 150
        mov di, 15
        xor si, si
        int 0F0h

;        mov ax, 1008h       ; RectF
;        mov bx, 300
;        mov cx, 2
;        mov dx, 319
;        mov si, 197
;        mov di, 0eh
;        int 0F0h

        mov ax, 0x21
        mov bx, 3000
        int 0F0h

        putdeb normterm
errend2:
        xor ax, ax          ; End program
        int 0F0h
errend:
        putdeb diberr
        jmp errend2

apic:   db 'DDDDDDDDDDDDDDD',13,10
        db 'D      B      D',13,10
        db ' D     B     D',13,10
        db '  D    B    D',13,10
        db '   D   B   D',13,10
        db '    D  B  D',13,10
        db '     D B D',13,10
        db '      DBD',13,10
        db '       D',13,10
        db '     CCCCC',13,10
        db 0
fntdat: dw 0,0FFFh,0
fntdat2: dw 4,0FFFh,1
eintext:    db 'Hello world!!!!',0
title:  db 'Sample application',0
einbild: db '/init/test.spm',0
diberr: db 'DIB ERROR',0
normterm: db 'Normal termination',0
itest: db 'Idle:',0
idone: db 'Done!',0
